package de.howaner.Poketherus.gui;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.utils.TextureRegionDrawable;
import de.howaner.Poketherus.resources.TextureManager;

public class Button extends TextButton {
	private static TextButtonStyle style;

	static {
		BitmapFont font = new BitmapFont(Gdx.files.internal("gui/mainmenu/font/font.fnt"), false);
		font.setScale(0.9f);

		TextureRegion image = new TextureRegion(TextureManager.BUTTONS);
		TextureRegion[][] regions = image.split(image.getRegionWidth(), image.getRegionHeight() / 3);

		style = new TextButtonStyle();
		style.up = new TextureRegionDrawable(regions[0][0]);
		style.checked = new TextureRegionDrawable(regions[0][0]);
		style.over = new TextureRegionDrawable(regions[1][0]);
		style.checkedOver = style.over;
		style.down = new TextureRegionDrawable(regions[2][0]);
		style.font = font;
	}

	public Button(String text) {
		super(text, style);
		this.setWidth(201f);
		this.setHeight(32f);
	}

}
