package de.howaner.Poketherus.gui;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.utils.Disposable;
import de.howaner.Poketherus.screens.GameScreen;

public class DebugRenderer implements Disposable {
	private final GameScreen screen;
	private boolean enabled = false;

	private BitmapFont font;
	private SpriteBatch textBatch;

	public DebugRenderer(GameScreen screen) {
		this.screen = screen;

		//Load font
		this.font = new BitmapFont();
		this.font.setColor(Color.WHITE);
		this.font.setScale(1.5f);

		this.textBatch = new SpriteBatch();
	}

	public void draw(Batch batch) {
		if (!this.enabled) {
			return;
		}

		this.textBatch.begin();
		this.font.draw(this.textBatch, "FPS: " + Gdx.graphics.getFramesPerSecond(), 8, 60);
		this.font.draw(this.textBatch, this.screen.getCurrentWorld().getName() + ", " + this.screen.getPlayer().getTileX() + ", " + this.screen.getPlayer().getTileY(), 8, 30);
		this.textBatch.end();
	}

	public boolean isEnabled() {
		return this.enabled;
	}

	public void setEnabled(boolean enabled) {
		this.enabled = enabled;
	}

	@Override
	public void dispose() {
		this.textBatch.dispose();
		this.font.dispose();

		this.textBatch = null;
		this.font = null;
	}

}
