package de.howaner.Poketherus.input;

import com.badlogic.gdx.Application.ApplicationType;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.InputProcessor;
import de.howaner.Poketherus.screens.OldMainMenuScreen;
import de.howaner.Poketherus.screens.util.MainMenuButton;

public class MainMenuInput implements InputProcessor {
	private OldMainMenuScreen screen;

	public MainMenuInput(OldMainMenuScreen screen) {
		this.screen = screen;
	}

	@Override
	public boolean keyDown(int key) {
		return false;
	}

	@Override
	public boolean keyUp(int key) {
		return false;
	}

	@Override
	public boolean keyTyped(char c) {
		return false;
	}

	@Override
	public boolean touchDown(int screenX, int screenY, int pointer, int button) {
		MainMenuButton b = this.screen.findMenuButton(screenX, screenY);
		if (b != null) {
			this.screen.clickButton(b);
		}
		return false;
	}

	@Override
	public boolean touchUp(int screenX, int screenY, int pointer, int button) {
		return false;
	}

	@Override
	public boolean touchDragged(int i, int i1, int i2) {
		return false;
	}

	@Override
	public boolean mouseMoved(int x, int y) {
		if (Gdx.app.getType() != ApplicationType.Android) {
			MainMenuButton button = this.screen.findMenuButton(x, y);
			this.screen.setHoverButton(button);
		}
		return false;
	}

	@Override
	public boolean scrolled(int i) {
		return false;
	}

}
