package de.howaner.Poketherus.map;

import com.badlogic.gdx.utils.Disposable;
import de.howaner.Poketherus.saveformat.TagBase;
import de.howaner.Poketherus.saveformat.TagShort;
import java.util.List;

public class MapLayer implements Disposable {
	private int id;
	private int width;
	private int height;
	private short[] tiles;

	public MapLayer(int id, MapTerrain map) {
		this(id, map.getWidth(), map.getHeight());
	}

	public MapLayer(int id, int width, int height) {
		this.id = id;
		this.width = width;
		this.height = height;
		this.tiles = new short[width * height];
	}

	public int getId() {
		return this.id;
	}

	public int getWidth() {
		return this.width;
	}

	public int getHeight() {
		return this.height;
	}

	public short[] getTiles() {
		return this.tiles;
	}

	public short getTile(int x, int y) {
		if (x < 0 || x >= this.getWidth() || y < 0 || y >= this.getHeight()) {
			return 0;
		}
		return this.tiles[y * this.getWidth() + x];
	}

	public void loadFromTagList(List<TagBase> list) {
		this.tiles = new short[this.getWidth() * this.getHeight()];
		for (int i = 0; i < list.size(); i++) {
			TagShort tag = (TagShort) list.get(i);
			this.tiles[i] = tag.getData();
		}
	}

	@Override
	public void dispose() {
		this.tiles = null;
	}

}
