package de.howaner.Poketherus.map.events;

import de.howaner.Poketherus.map.MapTerrain;
import de.howaner.Poketherus.saveformat.TagCompound;

public class EventInteract extends Event {
	private boolean requireInteract = false;
	private String scriptName = "";

	public EventInteract(MapTerrain map, int posX, int posY) {
		super(map, posX, posY);
	}

	public boolean isRequireInteract() {
		return this.requireInteract;
	}

	public void setRequireInteract(boolean requireInteract) {
		this.requireInteract = requireInteract;
	}

	public String getScriptName() {
		return this.scriptName;
	}

	public void setScriptName(String scriptName) {
		this.scriptName = scriptName;
	}

	@Override
	public void loadFromCompound(TagCompound compound) {
		super.loadFromCompound(compound);
		this.requireInteract = compound.getBoolean("RequireInteract");
		this.scriptName = compound.getString("ScriptName");
	}

	@Override
	public void saveToCompound(TagCompound compound) {
		super.saveToCompound(compound);
		compound.setBoolean("RequireInteract", this.requireInteract);
		compound.setString("ScriptName", this.scriptName);
	}

	@Override
	public EventType getType() {
		return EventType.INTERACT;
	}

}
