package de.howaner.Poketherus.map.renderer.particle;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.Animation;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.Sprite;

public class Particle extends Sprite {
	private final Animation animations;
	private float time;

	public Particle(Animation animations) {
		super(animations.getKeyFrame(0).getTexture(), 16, 16);
		this.animations = animations;
		this.time = 0f;

		this.animations.setPlayMode(Animation.PlayMode.NORMAL);
	}

	@Override
	public void draw(Batch batch) {
		this.setRegion(this.animations.getKeyFrame(this.time));
		this.time += Gdx.graphics.getDeltaTime();

		super.draw(batch);
	}

	public Animation getAnimations() {
		return this.animations;
	}

	public float getTime() {
		return this.time;
	}

	public boolean isFinished() {
		return this.animations.isAnimationFinished(this.time);
	}

}
