package de.howaner.Poketherus.multiplayer;

import com.google.common.collect.BiMap;
import com.google.common.collect.HashBiMap;
import de.howaner.Poketherus.multiplayer.packets.in.*;

public class Packets {
	private static BiMap<Integer, Class<? extends InPacket>> packets = HashBiMap.create();

	static {
		addPacket(0, PacketInKeepAlive.class);
		addPacket(1, PacketInDisconnect.class);
		addPacket(2, PacketInAuthenticationRequest.class);
		addPacket(3, PacketInLoginSuccess.class);
		addPacket(4, PacketInPlayerSpawn.class);
		addPacket(5, PacketInEntityRemove.class);
		addPacket(6, PacketInEntityTeleport.class);
		addPacket(7, PacketInEntityWalk.class);
		addPacket(8, PacketInFadeScreen.class);
		addPacket(9, PacketInFadeEntity.class);
		addPacket(10, PacketInSwitchWorld.class);
		addPacket(11, PacketInUpdateEntityID.class);
		addPacket(12, PacketInEntityState.class);
	}

	public static InPacket createPacketInstance(int packetID) {
		Class<? extends InPacket> packetClass = getPacketClass(packetID);
		if (packetClass == null) {
			return null;
		}

		try {
			return packetClass.newInstance();
		} catch (Exception e) {
			return null;
		}
	}

	public static Class<? extends InPacket> getPacketClass(int packetID) {
		return packets.get(packetID);
	}

	public static void addPacket(int packetID, Class<? extends InPacket> packetClass) {
		packets.put(packetID, packetClass);
	}

}
