package de.howaner.Poketherus.multiplayer.netty;

import com.badlogic.gdx.Gdx;
import de.howaner.Poketherus.multiplayer.PacketBuffer;
import de.howaner.Poketherus.multiplayer.Packets;
import de.howaner.Poketherus.multiplayer.packets.in.InPacket;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.ByteToMessageDecoder;
import java.util.List;

public class MessageDeserializer extends ByteToMessageDecoder {

	@Override
	protected void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> out) throws Exception {
		int readableBytes = in.readableBytes();
		if (readableBytes != 0) {
			PacketBuffer buffer = new PacketBuffer(in);
			int packetID = buffer.readVarInt();
			InPacket packet = Packets.createPacketInstance(packetID);

			if (packet == null) {
				throw new Exception("Unknown packet id: " + packetID);
			}

			try {
				packet.readPacketData(buffer);
			} catch (Exception ex) {
				Gdx.app.error("Multiplayer", "Can't read packet data", ex);
			}
			if (in.readableBytes() > 0) {
				throw new Exception("Packet was larger than I expected, found " + in.readableBytes() + " bytes extra whilst reading packet " + packetID);
			}

			out.add(packet);
		}
	}

}
