package de.howaner.Poketherus.multiplayer.netty;

import de.howaner.Poketherus.multiplayer.PacketBuffer;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.ByteToMessageDecoder;
import io.netty.handler.codec.CorruptedFrameException;
import java.util.List;

public class MessageLengthDeserializer extends ByteToMessageDecoder {

	@Override
	protected void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> out) throws Exception {
		in.markReaderIndex();
		byte[] lengthBytes = new byte[3];

		for (int i = 0; i < 3; i++) {
			if (!in.isReadable()) {
				in.resetReaderIndex();
				return;
			}
			lengthBytes[i] = in.readByte();

			// If the byte is higher/equal null. -> Length is available
			if (lengthBytes[i] >= 0) {
				PacketBuffer buffer = new PacketBuffer(Unpooled.wrappedBuffer(lengthBytes));

				try {
					int packetLength = buffer.readVarInt();
					if (in.readableBytes() < packetLength) {
						in.resetReaderIndex();
						return;
					}

					out.add(in.readBytes(packetLength));
				} finally {
					buffer.release();
				}

				return;
			}
		}

		throw new CorruptedFrameException("length wider than 21-bit");
	}

}
