package de.howaner.Poketherus.multiplayer.packets.in;

import de.howaner.Poketherus.multiplayer.ClientHandle;
import de.howaner.Poketherus.multiplayer.PacketBuffer;

public class PacketInFadeEntity extends InPacket {
	private int entityID;
	private FadeType fadeType;
	private float duration;

	public int getEntityID() {
		return this.entityID;
	}

	public FadeType getFadeType() {
		return this.fadeType;
	}

	public float getDuration() {
		return this.duration;
	}

	@Override
	public int getPacketID() {
		return 9;
	}

	@Override
	public void readPacketData(PacketBuffer buffer) throws Exception {
		this.entityID = buffer.readVarInt();
		this.fadeType = FadeType.values()[buffer.readByte()];
		this.duration = buffer.readFloat();
	}

	@Override
	public void handlePacket(ClientHandle handler) {
		handler.handlePacketFadeEntity(this);
	}

	public enum FadeType {
		FADE_OUT, FADE_IN;
	}

}
