package de.howaner.Poketherus.multiplayer.packets.out;

import de.howaner.Poketherus.entity.EntityFace;
import de.howaner.Poketherus.entity.Player;
import de.howaner.Poketherus.multiplayer.PacketBuffer;
import de.howaner.Poketherus.util.Location;

public class PacketOutPlayerMove extends OutPacket {
	private EntityFace face;
	private Location currentLocation;

	public PacketOutPlayerMove(EntityFace face, Location currentLocation) {
		this.face = face;
		this.currentLocation = currentLocation;
	}

	public PacketOutPlayerMove(Player player) {
		this.face = player.getFaceDirection();
		this.currentLocation = player.getLocation();
	}

	@Override
	public int getPacketID() {
		return 4;
	}

	@Override
	public void writePacketData(PacketBuffer buffer) throws Exception {
		buffer.writeByte(this.face.ordinal());
		buffer.writeLocation(this.currentLocation, false);
	}

}
