package de.howaner.Poketherus.world;

import de.howaner.Poketherus.entity.Entity;
import de.howaner.Poketherus.map.MapTerrain;
import de.howaner.Poketherus.map.MapTileset;
import de.howaner.Poketherus.map.MapWalkData;
import de.howaner.Poketherus.map.events.Event;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

public class World {
	private final MapTerrain terrain;
	private final Map<Integer, Entity> entities = new HashMap<Integer, Entity>();

	public void spawnEntity(Entity entity) {
		this.entities.put(entity.getEntityID(), entity);
	}

	public Entity getEntity(int entityID) {
		return this.entities.get(entityID);
	}

	public Collection<Entity> getEntities() {
		return this.entities.values();
	}

	public void removeEntity(int entityID) {
		this.entities.remove(entityID);
	}

	public void removeAllEntities() {
		this.entities.clear();
	}

	public World(MapTerrain terrain) {
		this.terrain = terrain;
	}

	public MapTerrain getTerrain() {
		return this.terrain;
	}

	public String getName() {
		return this.terrain.getName();
	}

	public String getJoinMessage() {
		return this.terrain.getJoinMessage();
	}

	public int getWidth() {
		return this.terrain.getWidth();
	}

	public int getHeight() {
		return this.terrain.getHeight();
	}

	public MapTileset getTileset() {
		return this.terrain.getTileset();
	}

	public short getTileAt(int x, int y, int layer) {
		return this.terrain.getTileAt(x, y, layer);
	}

	public MapWalkData.WalkDataType getWalkdataAt(int x, int y) {
		return this.terrain.getWalkdataAt(x, y);
	}

	public Event getEventAt(int x, int y) {
		return this.terrain.getEventAt(x, y);
	}

}
